;============================================================================;
;                                  file.asm                                  ;


delete
         lea        string\delete(pc),a2
         lea        string\deleted(pc),a3
         lea        filelib::delete,a4
         lea        restore\realloc_and_window\go_to_top(pc),a5
         clr.w      d0
         bra        confirm

copy
         lea        string\copy(pc),a2
         lea        string\copied(pc),a3
         lea        copy_selection(pc),a4
         lea        restore\realloc_and_window(pc),a5
         moveq.w    #1,d0
         bra        confirm

move
         lea        string\move(pc),a2
         lea        string\moved(pc),a3
         lea        move_selection(pc),a4
         lea        restore\realloc_and_window(pc),a5
         moveq.w    #2,d0
         bra        confirm

archive
         lea        string\archived(pc),a3
         lea        archive_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

unarchive
         lea        string\unarchived(pc),a3
         lea        unarchive_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

zip
         lea        string\zipped(pc),a3
         lea        zip_selection(pc),a4
         lea        restore\realloc_and_window(pc),a5
         bra        apply_to_selection

unzip
         lea        string\unzipped(pc),a3
         lea        unzip_selection(pc),a4
         lea        restore\realloc_and_window(pc),a5
         bra        apply_to_selection

lock
         lea        string\locked(pc),a3
         lea        lock_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

unlock
         lea        string\unlocked(pc),a3
         lea        unlock_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

hide
         lea        string\hiden(pc),a3
         lea        hide_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

unhide
         lea        string\unhiden(pc),a3
         lea        unhide_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

protect
         lea        string\protected(pc),a3
         lea        protect_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection

unprotect
         lea        string\unprotected(pc),a3
         lea        unprotect_selection(pc),a4
         lea        draw_details\page(pc),a5
         bra        apply_to_selection


copy_selection
         bclr.b     #5,11(a2)
         move.w     d4,d2
         jmp        filelib::copy

move_selection
         bclr.b     #5,11(a2)
         move.w     d4,d2
         jmp        filelib::move

archive_selection
         btst.w     #9,10(a2)
         bne.s      archive_selection\exit
         jmp        filelib::archive

unarchive_selection
         btst.w     #9,10(a2)
         beq.s      unarchive_selection\exit
         jmp        filelib::unarchive

archive_selection\exit
unarchive_selection\exit
         clr.b      d2
         rts

hide_selection
         tst.b      (a2)
         sne.b      d2
         beq.s      hide_selection\exit               ; protected ?
         bset.b     #4,11(a2)
         seq.b      d2
hide_selection\exit
         rts

unhide_selection
         tst.b      (a2)
         sne.b      d2
         beq.s      unhide_selection\exit             ; protected ?
         bclr.b     #4,11(a2)
         sne.b      d2
unhide_selection\exit
         rts

lock_selection
         btst.w     #9,10(a2)                         ; archived ?
         seq.b      d2
         bset.b     #3,11(a2)
         seq.b      d2
lock_selection\exit
         rts

unlock_selection
         btst.w     #9,10(a2)                         ; archived ?
         seq.b      d2
         bne.s      unlock_selection\exit
         bclr.b     #3,11(a2)
         sne.b      d2
unlock_selection\exit
         rts

protect_selection
         tst.b      (a2)
         sne.b      d2
         beq.s      protect_selection\exit
         move.b     (a2),8(a2)
         clr.b      (a2)
         bset.b     #4,11(a2)
protect_selection\exit
         rts

unprotect_selection
         tst.b      (a2)
         seq.b      d2
         bne.s      unprotect_selection\exit
         move.b     8(a2),(a2)
         clr.b      8(a2)
         bclr.b     #4,11(a2)
unprotect_selection\exit
         rts

zip_selection
         clr.b      d1                  ; 0 = zip
         lea        string\compressing(pc),a1
         bra.s      zip_or_unzip_selection

unzip_selection
         moveq.b    #1,d1               ; 1 = unzip
         lea        string\extracting(pc),a1

zip_or_unzip_selection
         move.l     a2,a0
         jsr        ziplib::iscomp
         sub.b      d1,d0
         tst.w      d0
         beq.s      zip_or_unzip_selection\exit
         move.l     a0,-(a7)
         move.l     a4,-(a7)
         move.l     a1,-(a7)
         pea        string
         jsr        tios::sprintf
         lea        string,a0
         bsr        show_status_line
         move.l     12(a7),a0
         add.l      #16,a7
         clr.b      d0
         jsr        ziplib::zipfile
         tst.b      d0
         seq.b      d0
zip_or_unzip_selection\exit
         move.b     d0,d2
         rts

;============================================================================;
;rename                                                                      ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed :                                                             ;

rename
         cmp.w      #-1,number_folders
         beq        wait_for_no_key

         lea        string\rename(pc),a0
         move.w     #rename_window\width,d4
         moveq.w    #rename_window\height,d5
         moveq.w    #1,d6
         moveq.w    #4,d7
         bsr        dialog_window\open
         moveq.w    #window_font,d3
         moveq.w    #rename_window\new_name\x,d0
         moveq.w    #rename_window\new_name\y,d1
         lea        string\new_name(pc),a0
         bsr        draw_string_a0
         bsr        get_handle\current
         moveq.w    #rename_window\input_name\x,d0
         moveq.w    #rename_window\input_name\y,d1
         moveq.w    #8,d2
         moveq.b    #1,d3
         move.l     a2,a0
         bsr        input_string
         bsr        dialog_window\clear
         tst.b      d2                        ; no name typed ?
         beq.s      rename\exit
         movem.l    a0/a2,-(a7)
         jsr        tios::strcmp              ; same name ?
         movem.l    (a7)+,a0/a2
         beq.s      rename\exit

         move.b     window(pc),d0
         addq.b     #1,d0
         and.b      #2,d0
         beq.s      rename\get_folderlisthandle

rename\get_folderhandle
         bsr        get_handle\folder\current
         bra.s      rename\get_index

rename\get_folderlisthandle
         move.w     #tios::FolderListHandle,d0

rename\get_index
         bsr        get_index\current
         bsr        save_all_screen
         bsr        wait_for_no_key
         bsr        system\partial_interrupts_on
         clr.w      tios::kb_vars+$1C
         jsr        filelib::rename
         bsr        system\partial_interrupts_off
         bsr        restore_all_screen
         tst.b      d2
         beq.s      rename\exit
         bsr        move_to\current
         bsr        invert
rename\exit
         bra        wait_for_no_key

;============================================================================;
;create_folder                                                               ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : void                                                        ;

create_folder
         clr.w      tios::kb_vars+$1C
         lea        string\create_folder(pc),a0
         move.w     #create_folder_window\width,d4
         moveq.w    #create_folder_window\height,d5
         moveq.w    #1,d6
         moveq.w    #4,d7
         bsr        dialog_window\open
         moveq.w    #window_font,d3
         moveq.w    #create_folder_window\new_name\x,d0
         moveq.w    #create_folder_window\new_name\y,d1
         lea        string\folder(pc),a0
         bsr        draw_string_a0
         moveq.w    #create_folder_window\input_name\x,d0
         moveq.w    #create_folder_window\input_name\y,d1
         moveq.w    #8,d2
         moveq.b    #1,d3
         bsr        input_string\empty_field
         bsr        dialog_window\clear
         tst.b      d2
         beq.s      create_folder\exit
         bsr        save_all_screen
         bsr        system\partial_interrupts_on
         jsr        filelib::createfolder
         bsr        system\partial_interrupts_off
         bsr        restore_all_screen
         tst.b      d2
         beq.s      create_folder\exit
         bsr        uninit_mode
         bsr        init\program\window
create_folder\exit
         bra        wait_for_no_key

;============================================================================;
;apply_to_selected_variable                                                          ;

apply_to_selected_variable
         clr.w      tios::kb_vars+$1C
         add.w      #1,6(a7)                          ; total counter
         move.l     12(a7),a0
         jsr        (a0)
         tst.b      d2                                ; d2 = success flag
         beq.s      apply_to_selected_variable\exit
         add.w      #1,4(a7)                          ; success counter
apply_to_selected_variable\exit
         rts

;============================================================================;
;apply_to_selection                                                          ;
;                                                                            ;
; each time it finds a selected variable:                                    ;
;           it executes (a4) with d0.w = folder handle                       ;
;                                 d1.w = variable index                      ;
;                                 a2.l = variable sym entry                  ;
;                                 a4.l = folder sym entry                    ;
; then it execute (a5)                                                       ;
; and it returns a0.l = "success/total "&(a3 string pointer)                 ;


apply_to_selection
         movem.l    a3-a5,-(a7)
         clr.w      -(a7)                     ; total counter
         clr.w      -(a7)                     ; success counter

         cmp.w      #-1,number_folders
         beq        apply_to_selection\exit

         cmp.w      #264,d6
         bne.s      apply_to_selection\confirmed

apply_to_selection\not_confirmed
         move.w     d0,2(a7)
         bra        apply_to_selection\exit

apply_to_selection\confirmed
         bsr        save_all_screen
         bsr        wait_for_no_key
         bsr        system\partial_interrupts_on
         bsr        uninit_mode
         move.w     number_folders(pc),d7        ; d7 = folder index

apply_to_selection\folder_loop
         bsr        unalloc_file_list
         move.w     d7,d1
         bsr        alloc_file_list\same_folder
         move.l     a2,handle\address
         move.l     a3,sym_table
         move.w     d1,d6                        ; d6 = file index

         move.w     d7,d1
         bsr        get_handle\folder
         move.w     d0,d5                        ; d5 = folder handle
         move.l     a2,a4                        ; a4 = folder sym entry

         cmp.w      #-1,d6
         beq.s      apply_to_selection\folder

apply_to_selection\file_loop
         move.w     d6,d1
         bsr        get_handle
         btst.b     #5,11(a2)                    ; selected files ?
         beq.s      apply_to_selection\file_loop\dbra

         move.w     d5,d0

         bsr        apply_to_selected_variable

apply_to_selection\file_loop\dbra
         dbf.s      d6,apply_to_selection\file_loop

apply_to_selection\folder
         move.l     a4,a2
         btst.b     #5,11(a2)                    ; selected folder ?
         beq.s      apply_to_selection\folder_loop\dbra
         move.w     d7,d1
         move.w     #tios::FolderListHandle,d0

         bsr        apply_to_selected_variable

apply_to_selection\folder_loop\dbra
         dbf.s      d7,apply_to_selection\folder_loop

         tst.w      2(a7)
         bne.s      apply_to_selection\restore_file_list

         bsr        unalloc_file_list
         move.w     current\folder(pc),d1
         bsr        alloc_file_list\same_folder
         bsr        init_mode

apply_to_selection\current
         move.b     window(pc),d0
         addq.b     #1,d0
         and.b      #2,d0
         beq.s      apply_to_selection\current\folder

apply_to_selection\current\file
         bsr        get_handle\folder\current
         move.w     d0,d2                ; saves d0
         bsr        get_handle\current   ; gets a2 = sym entry
         move.w     d2,d0                ; restores d0
         bsr        get_index\current

         bsr        apply_to_selected_variable

         bra.s      apply_to_selection\restore_file_list

apply_to_selection\current\folder
         move.w     #tios::FolderListHandle,d0
         move.w     d0,d2                     ; saves d0
         bsr        get_handle\folder\current ; gets a2 = sym entry
         move.w     d2,d0                     ; restores d0

         bsr        apply_to_selected_variable

apply_to_selection\restore_file_list
         bsr        system\partial_interrupts_off
         bsr        restore_all_screen
;         tst.w      (a7)                       ; don't restore screen if
;         beq.s      apply_to_selection\exit    ; none copied/archived/...

         move.l     12(a7),a0
         jsr        (a0)

apply_to_selection\exit
         pea        string\ratio(pc)
         pea        string
         jsr        tios::sprintf
         lea        24(a7),a7
         lea        string,a0
         move.b     #1,error_flag
         bra        wait_for_no_key

;============================================================================;
;restore                                                                     ;

restore\realloc_and_window\go_to_top
         clr.w      current
         clr.w      cursor
restore\realloc_and_window
         bsr        uninit_mode
         bsr        unalloc_file_list
         bsr        unalloc_folder_list
         bsr        init\program\window
         bra        wait_for_no_key

;============================================================================;
;confirm                                                                     ;

confirm
         cmp.w      #-1,number_folders
         beq        apply_to_selection

         btst.b     d0,confirmations_flag
         beq        apply_to_selection

         movem.l    a2-a3,-(a7)
confirm\count

         bsr        uninit_mode
         move.w     number_folders(pc),d7        ; d7 = folder index
         clr.l      d4                           ; d4 = counter

confirm\count\folder_loop
         bsr        unalloc_file_list
         move.w     d7,d1
         bsr        alloc_file_list\same_folder
         cmp.w      #-1,d1
         beq.s      confirm\count\folder_loop\folder
         move.l     a2,handle\address
         move.l     a3,sym_table
         move.w     d1,d6
confirm\count\file_loop
         move.w     d6,d1
         bsr        get_handle
         btst.b     #5,11(a2)
         beq.s      confirm\count\file_loop\dbra
         addq.w     #1,d4
confirm\count\file_loop\dbra
         dbf.s      d6,confirm\count\file_loop
confirm\count\folder_loop\folder
         move.w     d7,d1
         bsr        get_handle\folder
         btst.b     #5,11(a2)
         beq.s      confirm\count\folder_loop\dbra
         addq.w     #1,d4
confirm\count\folder_loop\dbra
         dbf.s      d7,confirm\count\folder_loop
         clr.b      d5
         tst.w      d4
         bne.s      confirm\count\restore_file_list
confirm\count\current
         moveq.w    #1,d4
         moveq.w    #1,d5

confirm\count\restore_file_list
         bsr        unalloc_file_list
         move.w     current\folder(pc),d1
         bsr        alloc_file_list\same_folder
         bsr        init_mode

         move.w     d4,d0
         movem.l    (a7)+,a2-a3

         cmp.b      #'D',(a2)
         sne.w      d2
         and.w      #4,d2
         beq.s      confirm\show_dialog_window

         move.b     #1,error_flag
         tst.b      d5
         beq.s      confirm\test_window
         lea        error\no_variables(pc),a0
         rts

confirm\test_window
         move.b     window(pc),d1
         addq.b     #1,d1
         and.b      #2,d1
         beq.s      confirm\show_dialog_window
         lea        error\dest_folder(pc),a0
         rts

confirm\show_dialog_window
         move.w     d0,-(a7)
         move.l     a2,a0
         move.w     #delete_window\width,d4
         moveq.w    #delete_window\height,d5
         add.w      d2,d5
         moveq.w    #1,d6
         moveq.w    #4,d7
         bsr        dialog_window\open

         move.w     d2,d7                      ; save d2
         move.l     a2,-(a7)
         pea        string\confirm
         pea        string
         jsr        tios::sprintf
         moveq.w    #window_font,d3
         moveq.w    #delete_window\confirm\x,d0
         moveq.w    #delete_window\confirm\y,d1
         sub.w      d7,d1
         bsr        draw_string

         cmp.b      #'D',(a2)
         beq.s      confirm\restore_stack

confirm\copy_or_move
         bsr        get_handle\current
         move.w     d0,d4
         move.l     a2,8(a7)
         move.l     #string\destination,4(a7)
         move.l     #string,(a7)
         jsr        tios::sprintf
         moveq.w    #delete_window\confirm\x,d0
         moveq.w    #delete_window\confirm\y+copy_window\dy,d1
         sub.w      d7,d1
         bsr        draw_string

confirm\restore_stack
         move.w     12(a7),d0
         lea        14(a7),a7

confirm\pause
         bsr        get_key
         cmp.w      #264,d6
         beq.s      confirm\clear_window
         cmp.w      #13,d6
         beq.s      confirm\clear_window
         bra.s      confirm\pause

confirm\clear_window
         bsr        dialog_window\clear
         bra        apply_to_selection


;                                  file.asm                                  ;
;============================================================================;