;============================================================================;
;                                  init.asm                                  ;
;============================================================================;

init\program

;         clr.b      ($60001A)           ; acknowledge autoint 6

         jsr        graphlib::clr_scr

         clr.w      d0
         moveq.w    #menu_corner\y,d1
         moveq.w    #menu_title\height,d2
         moveq.w    #3,d3

draw_verticals_loop
         add.w      #menu_title\width,d0        ; 4 vertical segments
         jsr        graphlib::vert
         dbra.s     d3,draw_verticals_loop

         move.w     #indicators\x+2,d0          ; vertical segment of the
         moveq.w    #indicators\y-1,d1          ; indicators
         moveq.w    #indicators\y+6,d2
         jsr        graphlib::vert

         clr.w      d0                          ; draws borders of screen
         clr.w      d1                          ; in XOR which makes holes
         clr.w      d3
         move.w     #lcd_width-1,d4
         moveq.w    #lcd_height-1,d5
         move.w     d1,d2
         add.b      d5,d2
         jsr        graphlib::vert
         add.b      d4,d0
         jsr        graphlib::vert
         move.w     d0,d2
         sub.b      d4,d2
         jsr        graphlib::horiz
         add.b      d5,d1
         jsr        graphlib::horiz

         moveq.w    #1,d0
         moveq.w    #menu_title\height+1,d1
         move.w     #lcd_width-2,d2
         jsr        graphlib::horiz             ; line beyond the menu

         moveq.w    #1,d0
         move.w     #lcd_height-9,d1
         jsr        graphlib::horiz             ; line over the indicators

 ifd ti92plus
         moveq.w    #menu_title\width-1,d0
         clr.w      d1
         moveq.w    #2,d2
         moveq.w    #1,d3
         clr.w      d4
         moveq.w    #3,d5
draw_cutted_corners_loop
         jsr        graphlib::fill
         add.w      #menu_title\width,d0
         dbra.s     d5,draw_cutted_corners_loop

         subq.w     #1,d0
         subq.w     #1,d2
         jsr        graphlib::fill
         clr.w      d0
         jsr        graphlib::fill

         bclr.b     #7,(LCD_MEM)
         bclr.b     #0,(LCD_MEM+29)
 endc

         moveq.w    #menu_title\y,d1            ; draws menu titles
         moveq.w    #menu_font,d3

         moveq.w    #F1\offset,d0
         lea        F1(pc),a0
         bsr        draw_string_a0
         moveq.w    #F2\offset,d0
         addq.l     #F2-F1,a0
         bsr        draw_string_a0
         moveq.w    #F3\offset,d0
         addq.l     #F3-F2,a0
         bsr        draw_string_a0
         move.w     #F4\offset,d0
         addq.l     #F4-F3,a0
         bsr        draw_string_a0
         move.w     #F5\offset,d0
         addq.l     #F5-F4,a0
         bsr        draw_string_a0

         move.b     #$FF,menu\number            ; doesn't start in a menu
         clr.b      menu\item
         clr.b      error_flag
         clr.b      in_repetition_flag
         clr.w      old_key
         clr.b      password_protect_flag
         clr.b      shift_flag
         clr.l      timer_20

         move.b     #initial_indicators_mask,indicators_mask
         move.b     #initial_indicators_value,indicators_value
         move.b     #initial_indicators_value,indicators_saved_value
         move.b     #%1111,old_indicators              ; nothing pressed
         bsr        refresh_indicators

init\program\window
         bsr        alloc_folder_list

         cmp.w      #-1,number_folders
         beq.s      init\program\window\no_folder

         bsr        alloc_file_list

         bsr        init_mode

         move.w     number(pc),d0
         cmp.w      current(pc),d0
         bcc.s      init\program\window\current
         move.w     d0,current

         move.w     number_to_draw(pc),d0
         cmp.w      cursor(pc),d0
         bcc.s      init\program\window\current
         move.w     d0,cursor

init\program\window\current
         bsr        uninit_mode

         cmp.w      #-1,number
         sne.b      d0
         and.b      d0,window

         bsr        init_mode
         bsr        draw_split_line
         cmp.b      #1,window
         beq.s      init\program\window_1
         bsr        move_to\current
         bra.s      init\program\cursor

init\program\window\no_folder
         move.b     #3,window
         bsr        init_mode
         bsr        clear_window
         lea        string\no_folder_found(pc),a0
         move.w     window\name_absciss(pc),d0
         moveq.w    #draw\y,d1
         moveq.w    #1,d3
         bra        draw_string_a0

init\program\window_1
         bsr        init_mode\window_0
         bsr        move_to\current
         bsr        init_mode\window_1
         bsr        switch\point_folder

init\program\cursor
         bra        invert

;============================================================================;
;init_mode                                                                   ;

init_mode\window_0
         clr.b      window
         bra.s      init_mode
init_mode\window_1
         move.b     #1,window

init_mode
         lea        window_absciss(pc),a0
         lea        window_parameters(pc),a1

         clr.l      d0
         move.b     window(pc),d0
         move.l     d0,d1
         mulu       #10,d0
         addq.b     #1,d1
         and.b      #2,d1
         lsl.b      #3,d1

         lea        0(a0,d0.l),a0
         lea        0(a1,d1.l),a1

         move.w     (a0)+,window\name_absciss
         move.w     (a0)+,window\type_absciss
         move.w     (a0)+,window\size_absciss
         move.w     (a0)+,window\attr_absciss
         move.w     (a0)+,window\width

         move.w     (a1)+,cursor
         move.w     (a1)+,current
         move.w     (a1)+,number
         move.w     (a1)+,number_to_draw
         move.l     (a1)+,handle\address
         move.l     (a1)+,sym_table
         rts

;============================================================================;
;uninit_mode                                                                 ;

uninit_mode
         lea        window_parameters(pc),a1
         clr.l      d0
         move.b     window(pc),d0
         addq.b     #1,d0
         and.b      #2,d0
         lsl.b      #3,d0
         lea        0(a1,d0.l),a1
         move.w     cursor,(a1)+
         move.w     current,(a1)+
         rts

;                                  init.asm                                  ;
;============================================================================;