;============================================================================;
;                                 setup.asm                                  ;

setup
         bsr        save_all_screen
         move.b     #5,menu\number
         bsr        menu\set_parameters
         move.b     (a5),d0                 ; menu X
         move.b     1(a5),d1                ; menu Y
         sub.b      #10,d1
         move.b     2(a5),d2                ; menu width
         moveq.w    #10,d3
         moveq.w    #1,d4
         jsr        graphlib::fill
         move.w     d2,d4
         move.w     d3,d5
	 jsr        graphlib::frame
         addq.b     #8,d1
         moveq.w    #2,d5
	 jsr        graphlib::frame
         lea        string\setup(pc),a0
         add.b      #setup_window\title\dx,d0
         subq.b     #6,d1
         clr.b      d3
         bsr        draw_string_a0
setup\show_text
         bsr        menu\show_2
         pea        setup\loop(pc)
         move.w     #4,-(a7)
         bchg.b     #0,shell_bolt_flag
         bra        setup\shell_bolt\first_draw

setup\loop
         bsr        pause
         pea        setup\loop(pc)
         bsr        menu\move
         cmp.w      #337,d6
         beq.s      setup\loop\right
         cmp.w      #340,d6
         beq.s      setup\loop\left
         cmp.w      #264,d6
         beq.s      setup_loop\esc
         cmp.w      #13,d6
         beq.s      setup_loop\enter
         rts

setup\loop\right
         tst.b      menu\item
         beq        setup\type_filter
         cmp.b      #1,menu\item
         beq        setup\attribute_filter
         cmp.b      #4,menu\item
         beq.s      setup\shell_bolt
         rts

setup\loop\left
         cmp.b      #4,menu\item
         beq.s      setup\shell_bolt
         rts

setup_loop\enter
         tst.b      menu\item
         beq        setup\type_filter
         cmp.b      #1,menu\item
         beq        setup\attribute_filter
         cmp.b      #2,menu\item
         beq        setup\set_editors
         cmp.b      #3,menu\item
         beq        setup\comfirmations
         cmp.b      #4,menu\item
         beq.s      setup\shell_bolt
         rts

setup_loop\esc
         addq.l     #4,a7
         bsr        menu\clear
         bra        restore\realloc_and_window

;============================================================================;
;setup\shell_bolt                                                            ;

setup\shell_bolt
         clr.w     -(a7)
setup\shell_bolt\first_draw
         lea        string,a0
         move.l     a0,-(a7)

         move.w     #menu_font,d0
         bsr        set_font

         move.w     #setup\shell_bolt\status\y,-(a7)
         move.w     #setup\shell_bolt\status\x\no,-(a7)
         move.l     #' NO ',(a0)
         clr.b      4(a0)
         bchg.b     #0,shell_bolt_flag
         bne.s      setup\shell_bolt\exit
         move.w     #setup\shell_bolt\status\x\yes,(a7)
         move.l     #'YES'*256,(a0)

setup\shell_bolt\exit
         jsr        tios::DrawStrXY
         bsr        set_font\default
         lea        10(a7),a7
         rts


;============================================================================;
;setup\type_filter                                                           ;

setup\type_filter
         move.w     handle\saved_screen,d7
         bsr        save_all_screen

         move.w     #type_filter_window\col1\x,d0
         moveq.w    #type_filter_window\col1\y,d1
         moveq.w    #type_filter_window\col1\width,d2
         moveq.w    #type_filter_window\col1\height,d3
         moveq.w    #1,d4
         jsr        graphlib::fill
         move.w     d2,d4
         move.w     d3,d5
         jsr        graphlib::frame

         addq.b     #3,d0
         addq.b     #3,d1
         moveq.w    #menu_font,d3
         moveq.w    #14,d6

setup\type_filter\item_loop
         moveq.w    #14,d4
         sub.w      d6,d4
         move.w     type_filter_flag(pc),d5
         btst.w     d4,d5
         sne.l      d5
         and.l      #10,d5
         lea        sprites\radio(pc),a0
         lea        0(a0,d5.l),a0
         jsr        graphlib::put_sprite
         move.w     d4,d5
         mulu       #5,d5
         lea        variable_type(pc),a0
         lea        0(a0,d5.l),a0
         addq.b     #7,d0
         bsr        draw_string_a0
         subq.b     #7,d0
         add.b      #7+menu_font*3,d1
         cmp.w      #7,d6
         bne.s      setup\type_filter\item_loop\dbf
         move.w     #type_filter_window\col2\x+3,d0
         moveq.w    #type_filter_window\col2\y+3,d1
setup\type_filter\item_loop\dbf
         dbf.s      d6,setup\type_filter\item_loop

         move.b     #6,menu\number
         clr.b      menu\item
         bsr        menu\invert_item

setup\type_filter\loop
         bsr        pause
         pea        setup\type_filter\loop(pc)
         bsr        menu\move
         cmp.w      #337,d6
         beq.s      setup\type_filter\right
         cmp.w      #340,d6
         beq.s      setup\type_filter\left
         cmp.w      #264,d6
         beq.s      setup\type_filter\exit
         cmp.w      #13,d6
         beq.s      setup\type_filter\enter
         rts

setup\type_filter\right
         bsr        menu\invert_item
         cmp.b      #6,menu\number
         beq.s      setup\type_filter\go_to_2nd_column

setup\type_filter\go_to_1st_column
         move.b     #6,menu\number
         bra        menu\invert_item

setup\type_filter\go_to_2nd_column
         cmp.b      #7,menu\item
         seq.b      d0
         add.b      d0,menu\item
         move.b     #7,menu\number
         bra        menu\invert_item

setup\type_filter\left
         cmp.b      #6,menu\number
         beq.s      setup\type_filter\exit
         bsr        menu\invert_item
         move.b     #6,menu\number
         bra        menu\invert_item

setup\type_filter\exit
         addq.l     #4,a7
         bsr        restore_all_screen
         move.w     d7,handle\saved_screen
         move.b     #5,menu\number
         move.b     #0,menu\item
         rts

setup\type_filter\enter
         cmp.b      #6,menu\number
         sne.w      d2
         and.w      #8,d2
         add.b      menu\item(pc),d2
         move.w     type_filter_flag(pc),d4
         bchg.w     d2,d4
         seq.l      d5
         and.l      #10,d5
         move.w     d4,type_filter_flag
         lea        sprites\radio(pc),a0
         lea        0(a0,d5.l),a0
         move.w     #type_filter_window\col1\x+3,d0
         moveq.w    #type_filter_window\col1\y+3,d1
         cmp.b      #7,menu\number
         bne.s      setup\type_filter\enter\put_sprite
         move.w     #type_filter_window\col2\x+3,d0
setup\type_filter\enter\put_sprite
         move.b     menu\item(pc),d2
         mulu       #7+menu_font*3,d2
         add.b      d2,d1
         move.b     #%11111100,d3
         jmp        graphlib::put_sprite_mask



;============================================================================;
;setup\attribute_filter                                                      ;

setup\attribute_filter
         move.w     handle\saved_screen,d7
         bsr        save_all_screen

         move.w     #attribute_filter_window\x,d0
         moveq.w    #attribute_filter_window\y,d1
         moveq.w    #attribute_filter_window\width,d2
         moveq.w    #attribute_filter_window\height,d3
         moveq.w    #1,d4
         jsr        graphlib::fill
         move.w     d2,d4
         move.w     d3,d5
         jsr        graphlib::frame

         addq.b     #3,d0
         add.b      #attribute_filter_window\height-7-menu_font*3,d1
         moveq.w    #menu_font,d3
         moveq.w    #6,d6

setup\attribute_filter\item_loop
         lea        sprites\radio(pc),a0
         btst.b     d6,attribute_filter_flag       ; ??? (pc) ???
         sne.l      d5
         and.l      #10,d5
         lea        0(a0,d5.l),a0
         jsr        graphlib::put_sprite
         lea        string\attribute_list(pc),a0
         move.w     d6,d5
         mulu       #10,d5
         lea        0(a0,d5.l),a0
         addq.b     #7,d0
         bsr        draw_string_a0
         subq.b     #7,d0
         sub.b      #7+menu_font*3,d1
         dbf.s      d6,setup\attribute_filter\item_loop

         move.b     #8,menu\number
         clr.b      menu\item
         bsr        menu\invert_item

setup\attribute_filter\loop
         bsr        pause
         pea        setup\attribute_filter\loop(pc)
         bsr        menu\move
         cmp.w      #13,d6
         beq.s      setup\attribute_filter\enter
         cmp.w      #340,d6
         beq.s      setup\attribute_filter\exit
         cmp.w      #264,d6
         beq.s      setup\attribute_filter\exit
         rts

setup\attribute_filter\exit
         addq.l     #4,a7
         bsr        restore_all_screen
         move.w     d7,handle\saved_screen
         move.b     #5,menu\number
         move.b     #1,menu\item
         rts

setup\attribute_filter\enter
         clr.w      d2
         move.b     menu\item(pc),d2
         bchg.b     d2,attribute_filter_flag
         seq.l      d5
         and.l      #10,d5
         lea        sprites\radio(pc),a0
         lea        0(a0,d5.l),a0
         move.w     #attribute_filter_window\x+3,d0
         moveq.w    #attribute_filter_window\y+3,d1
         mulu       #7+menu_font*3,d2
         add.b      d2,d1
         move.b     #%11111100,d3
         jmp        graphlib::put_sprite_mask

;============================================================================;
;setup\set_editors                                                           ;

setup\set_editors
         addq.l     #4,a7
         bsr        menu\clear

         lea        string\set_viewers(pc),a0
         clr.b      11(a0)
         move.w     #set_editors_window\width,d4
         moveq.w    #set_editors_window\height,d5
         moveq.w    #2,d6
         moveq.w    #4,d7
         bsr        dialog_window\open
         lea        string\set_viewers(pc),a0
         move.b     #160,11(a0)

         lea        string\text_viewer_name(pc),a0
         moveq.w    #set_editors_window\item_name\x,d0
         moveq.w    #set_editors_window\item_name\y,d1
         moveq.w    #window_font,d3
         bsr        draw_string_a0

         lea        string\pic_viewer_name(pc),a0
         add.b      #set_editors_window\item\dy,d1
         bsr        draw_string_a0

         lea        string\pv_viewer_name(pc),a0
         add.b      #set_editors_window\item\dy,d1
         bsr        draw_string_a0

         move.w     #set_editors_window\item_input\x,d0
         moveq.w    #set_editors_window\item_input\y+window_font*2+10,d1
         moveq.w    #51,d4
         moveq.w    #window_font*2+8,d5
         jsr        graphlib::frame

         add.b      #window_font*2+10,d1
         jsr        graphlib::frame

         addq.b     #1,d0
         addq.b     #2,d1
         lea        string\pv_viewer(pc),a0
         bsr        draw_string_a0

         lea        string\pic_viewer(pc),a0
         sub.b      #set_editors_window\item\dy,d1
         bsr        draw_string_a0

         sub.l      #30,a7
         lea        string\viewers(pc),a0
         move.l     (a0)+,(a7)
         move.l     (a0)+,4(a7)
         move.l     (a0)+,8(a7)
         move.l     (a0)+,12(a7)
         move.l     (a0)+,16(a7)
         move.l     (a0)+,20(a7)
         move.l     (a0)+,24(a7)
         move.w     (a0)+,28(a7)

         clr.b      d4

setup\set_editors\loop
         clr.l      d0
         move.b     d4,d0
         mulu       #10,d0
         lea        0(a7,d0.l),a0
         move.l     a0,a1
         move.w     #set_editors_window\item_input\x,d0
         move.b     d4,d1
         mulu       #set_editors_window\item\dy,d1
         add.w      #set_editors_window\item_input\y,d1
         moveq.w    #8,d2
         moveq.b    #3,d3
         bsr        input_string

         move.l     (a0)+,(a1)+
         move.l     (a0)+,(a1)+

         cmp.w      #13,d6
         beq.s      setup\set_editors\enter
         cmp.w      #264,d6
         beq.s      setup\set_editors\exit

         cmp.w      #338,d6
         bne.s      setup\set_editors\move_down

setup\set_editors\move_up
         tst.b      d4
         seq.b      d0
         and.b      #3,d0
         add.b      d0,d4
         subq.b     #1,d4
         bra.s      setup\set_editors\loop

setup\set_editors\move_down
         addq.b     #1,d4
         cmp.b      #3,d4
         sne.b      d0
         and.b      d0,d4
         bra.s      setup\set_editors\loop

setup\set_editors\enter
         lea        string\viewers(pc),a0
         move.l     (a7),(a0)+
         move.l     4(a7),(a0)+
         move.l     8(a7),(a0)+
         move.l     12(a7),(a0)+
         move.l     16(a7),(a0)+
         move.l     20(a7),(a0)+
         move.l     24(a7),(a0)+
         move.w     28(a7),(a0)+

setup\set_editors\exit
         lea        30(a7),a7
         bsr        dialog_window\clear
         bra        restore\realloc_and_window

;============================================================================;
;setup\comfirmations                                                         ;

setup\comfirmations
         addq.l     #4,a7
         bsr        menu\clear

         lea        string\confirmations(pc),a0
         clr.b      13(a0)
         move.w     #confirmations_window\width,d4
         moveq.w    #confirmations_window\height,d5
         clr.w      d6
         clr.w      d7
         bsr        dialog_window\open
         lea        string\confirmations(pc),a0
         move.b     #160,13(a0)

         moveq.w    #confirmations_window\item\x,d0
         moveq.w    #confirmations_window\item\bottom\y,d1
         moveq.w    #menu_font,d3
         moveq.w    #2,d6

setup\confirmations\display_loop
         lea        sprites\radio(pc),a0
         btst.b     d6,confirmations_flag
         sne.l      d5
         and.l      #10,d5
         lea        0(a0,d5.l),a0
         jsr        graphlib::put_sprite
         lea        string\confirmations_items(pc),a0
         move.w     d6,d5
         mulu       #19,d5
         lea        0(a0,d5.l),a0
         addq.b     #7,d0
         bsr        draw_string_a0
         subq.b     #7,d0
         sub.b      #7+menu_font*3,d1
         dbf.s      d6,setup\confirmations\display_loop

         move.b     #9,menu\number
         clr.b      menu\item
         bsr        menu\invert_item

setup\confirmations\loop
         bsr        pause
         pea        setup\confirmations\loop(pc)
         bsr        menu\move
         cmp.w      #13,d6
         beq.s      setup\confirmations\enter
         cmp.w      #264,d6
         beq.s      setup\confirmations\exit
         rts

setup\confirmations\enter
         clr.w      d2
         move.b     menu\item(pc),d2
         bchg.b     d2,confirmations_flag
         seq.l      d5
         and.l      #10,d5
         lea        sprites\radio(pc),a0
         lea        0(a0,d5.l),a0
         moveq.w    #confirmations_window\item\x,d0
         moveq.w    #confirmations_window\item\y,d1
         mulu       #7+menu_font*3,d2
         add.b      d2,d1
         move.b     #%11111100,d3
         jmp        graphlib::put_sprite_mask

setup\confirmations\exit
         addq.l     #4,a7
         move.b     #-1,menu\number
         clr.b      menu\item
         bsr        dialog_window\clear
         bra        restore\realloc_and_window

;                                 setup.asm                                  ;
;============================================================================;
